#!/bin/tcsh -f 

# Simple shell script to analyze data from the program rw2.c
# To see data run as:
# % cc -O2 rw2.c -o rw2
# % rw2-anal.csh > rw2-anal.out
# % grep ^R2 rw2-anal.out
# % grep ^Al rw2-anal.out
# etc. etc.
# To plot results see gnuplot script rw2-anal-plot and use as:
# % gnuplot
# gnuplot> load "rw2-anal-plot"
set Nwalk = 1000
# L = 6*sqrt(N)
set Ns    = (32 64 128 256 512 1024 2048 4096 8192 16384 32768 65536)
set Ls    = (34 49  68  97 136  193  272  385  544   769  1087  1537)
#set Ns    = (32 64 128 256 512 1024 2048 4096)
#set Ls    = (34 49  68  97 136  193  272  385)
set Ns    = (131072 262144 524288 1048576 2097152 4194304 8388608 16777216)
set Ls    = (  2173   3073   4345    6145    8689   12289   17378    24577)
set Ns    = (8388608 16777216)
set Ls    = (  14482    20481)


foreach N ($Ns)
 set L = $Ls[1]
 shift Ls
 set dat = rwalk2.$N.dat
 (/usr/bin/time ./rw2 $Nwalk $N $L) >& $dat
 gzip -f $dat
 set dat = $dat.gz
 echo -n "R2  $N  " # Compute 
 zgrep ^R    $dat | awk '{print $3}' | ./average
 echo -n "x   $N  "
 zgrep ^R    $dat | awk '{print $4}' | ./average
 echo -n "y   $N  "
 zgrep ^R    $dat | awk '{print $5}' | ./average
 echo -n "n   $N  "
 zgrep ^nret $dat | awk '{print $2}' | ./average
 echo -n "Al  $N  "
 set A1 = (`zgrep ^Al $dat | awk '{print $4}' | ./average`)
 set A2 = (`zgrep ^Al $dat | awk '{print $5}' | ./average`)
 set l0 = (`zgrep ^Al $dat | awk '{print $6}' | ./average`)
 set l1 = (`zgrep ^Al $dat | awk '{print $7}' | ./average`)
 set l2 = (`zgrep ^Al $dat | awk '{print $8}' | ./average`)
 set l3 = (`zgrep ^Al $dat | awk '{print $9}' | ./average`)
 echo "$A1   $A2   $l0   $l1   $l2   $l3"
end
