/************************   init.c ********************************/
#include "include.h"

/* start= 0  cold
          1  hot
         -1 old config*/
void init(int argc, char **argv){
  int    i;
  size_t len =1024;
  char  *buf;
  double obeta=-1.0;
  int    oseed=-1,OL=-1;
  FILE  *fin;

  /*define parameters from options:*/
  L=-1;beta=-1.;nsweep=-1;start=-1;seed=-1;
  get_the_options(argc,argv);
  if( start == 0 || start == 1){
    if(L     <  0 )locerr("L has not been set."   );
    if(seed  <  0 )locerr("seed has not been set.");
    if(beta  <  0 )locerr("beta has not been set.");
    /*derived parameters*/
    N=L*L; XNN=1; YNN = L;
    /*allocate memory space for spins: */
    s = (int *)malloc((size_t) (N*sizeof(int))); 
    if (!s) locerr("allocation failure in s[N]");/*if null pointer...*/
  }
  if(start  < 0 )locerr("start has not been set.");
  if(nsweep < 0 )locerr("nsweep has not been set");
  /*Initialize probabilities:*/
  for(i=2;i<5;i+=2) prob[i] = exp(-2*beta*i);
  /*Initial Configuration: cold (0), hot (1) and old (2)*/
  switch(start){
  case 0:/*cold start*/
    simmessage(stdout);
    for(i=0;i<N;i++) s[i]=1;
    break;
  case 1:/*hot start*/
    simmessage(stdout);
    for(i=0;i<N;i++){
      if(drandom() < 0.5)
	s[i] =  1;
      else
	s[i] = -1;
    }
    break;
  case 2:/*start from old configuration*/
    if(!(fin = fopen("conf","r")))locerr("Configuration file conf not found");
    buf=(char *)malloc((size_t) (len*sizeof(char)));/*allocate space for buf*/
    getline(&buf,&len,fin); /*do:  "man getline" to understand usage...*/
    // to %*s modifier diabasei string kai to agnoei...
    fscanf(fin,"%*s %d %*s %d %*s %lf %*s %ld",&OL,&OL,&obeta,&oseed);
    /* we check in case L has also been given by the options */
    if( L <  0  )L=OL;
    if( L != OL )locerr("Given L different from the one read from conf");
    N=L*L; XNN=1; YNN = L;
    if(seed < 0 ) seed = oseed;/*option overrides config*/
    if(beta < 0.) beta = obeta;
    s = (int *)malloc((size_t) (N*sizeof(int)));
    if (!s) locerr("allocation failure in s[N]");
    for(i=0;i<N;i++)
      if( fscanf(fin,"%d",&s[i]) != 1 || (s[i] != 1 && s[i] != -1)) 
	locerr("conf ended before reading s[N]");
    fclose(fin);
    //    free((char *)buf); /*free allocated space for buffer buf*/
    simmessage(stdout);
    break;
  default:
    printf("start= %d not valid. Exiting....\n",start);
    exit(1);
    break;
  }

}
