
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include "nrutil.h"
#include "nrutil-ext.h"

#define  TRUE  1
#define  FALSE 0
#define  STRLEN 200
#define  MAXDAT 100000
char prog[STRLEN];
double N,M,NE,beta; /*Normalization*/
int JACK;
int VERBOSE;
int maxdat;
main(int argc, char **argv){

  int i,j;
  int ndat,binw,bin;
  double *O,*O2,*O4,a,b,avO,avO2,erO,erO2,avchi,erchi,avO4,erO4;
  double *OE,*O2E,*O4E;
  double *E,*E2,*E4;
  double avE,erE;
  double *chi,*cum,avcum,ercum;
  double *chie,*cume,*cumd,*lm,*lmd;
  double avchie,avcume,avcumd,avlm,avlmd;
  double erchie,ercume,ercumd,erlm,erlmd;
  double *cov,avcov,ercov;
  double *x,*y;
  FILE *fp;

  strcpy(prog,(char *)basename(argv[0]));
  maxdat=-1;N=1.0;JACK=10;M=-1.0;VERBOSE=FALSE;NE=1.0;beta=1.0;
  get_the_options(argc,argv);
  if( M <= 0.0 ) M=N;
  if( maxdat <= 0 ) maxdat = MAXDAT;

  if( optind == argc ) fp = stdin;
  if( optind == argc - 1 ) 
    if( ! (fp=fopen(argv[optind],"r")))
      locerr("Could not open data file");
  if( optind <  argc - 1 )
    locerr("Supply only one data file");
  O   = cdvector(1,JACK);O2  = cdvector(1,JACK);O4  = cdvector(1,JACK);
  OE  = cdvector(1,JACK);O2E = cdvector(1,JACK);O4E = cdvector(1,JACK);
  E   = cdvector(1,JACK);E2  = cdvector(1,JACK);E4  = cdvector(1,JACK);
  chi = cdvector(1,JACK);cum = cdvector(1,JACK);chie= cdvector(1,JACK);
  cume= cdvector(1,JACK);cumd= cdvector(1,JACK);lm  = cdvector(1,JACK);
  lmd = cdvector(1,JACK);cov = cdvector(1,JACK);

  x   = dvector(1,maxdat);y = dvector(1,maxdat);

  ndat = 1;
  while( fscanf(fp,"%lg%lg",&y[ndat],&x[ndat]) == 2){
    if(ndat == maxdat){
      fprintf(stderr,"%s: Only %d data read. Use -d option for more.\n",
	      prog,ndat);
      ndat++;
      break;
    }
    ndat++;
  }
  ndat--;
  binw = ndat/JACK;
  if( binw < 1 ){
    fprintf(stderr,
	    "%s: Only ndat= %d data read. JACK= %d, binw=ndat/JACK= %d\n", 
	    prog,ndat,JACK,binw);
    exit(1);
  }
  ndat = binw * JACK;/* Only full bins are considered*/
  rewind(fp);
  
  for(i=1;i<= ndat;i++){
    a = x[i]; b = y[i];
    for(j=1;j<=JACK;j++)
      if( (i-1)/binw != j -1 ){
	O [j]  += a; O2[j] += a*a; O4[j] += a*a*a*a;
	E [j]  += b; E2[j] += b*b; E4[j] += b*b*b*b;
	O4E[j] += a*a*a*a*b; 
	O2E[j] += a*a*b;
	OE [j] += a*b;
      }
  }

  /*ndat now is the number of data elements in each bin*/
  ndat -= binw;
  avO   = 0.0; erO   = 0.0; avE    = 0.0; erE = 0.0;
  avchi = 0.0; erchi = 0.0; avchie = 0.0; erchie = 0.0;
  avcum = 0.0; ercum = 0.0; avcume = 0.0; ercume = 0.0;
  avcumd= 0.0; ercumd= 0.0; avlm   = 0.0; erlm   = 0.0;
  avlmd = 0.0; erlmd = 0.0; avcov  = 0.0; ercov  = 0.0;
  for(j=1;j<=JACK;j++){
    O   [j] /= N*ndat; O2[j] /= N*N*ndat;/*We put normalization here*/
    O4  [j] /= N*N*N*N*ndat;
    E   [j] /= NE*ndat; E2[j] /= NE*NE*ndat;/*We put normalization here*/
    E4  [j] /= NE*NE*NE*NE*ndat;
    OE  [j] /= N       *NE*ndat;
    O2E [j] /= N*N     *NE*ndat;
    O4E [j] /= N*N*N*N *NE*ndat;
    chi [j]  = O2[j] - O[j]*O[j];/*Fluctuations here*/
    chie[j]  = E2[j] - E[j]*E[j];
    cum [j]  = O4[j]/(O2[j]*O2[j]);
    cume[j]  = E4[j]/(E2[j]*E2[j]);
    cumd[j]  = (O2[j]*O4E[j]+O4[j]*(O2[j]*E[j]-2.0 * O2E[j]))/
      (O2[j]*O2[j]*O2[j]);
    lm  [j]  = E[j] - OE [j]/O [j];
    lmd [j]  = E[j] - O2E[j]/O2[j];
    cov [j]  = (OE[j]-E[j]*O[j])/sqrt(chie[j]*chi[j]);
    avO    += O  [j];
    avchi  += chi[j];
    avcum  += cum[j];
    avcumd += cumd[j];
    avcume += cume[j];
    avE    += E   [j];
    avchie += chie[j];
    avlm   += lm  [j];
    avlmd  += lmd [j];
    avcov  += cov [j];
  }
  avO    /= JACK;avchi   /= JACK;avcum /= JACK;avE    /= JACK; avchie /= JACK;
  avcume /= JACK; avcumd /= JACK; avlm /= JACK; avlmd /= JACK; avcov  /= JACK;
  for(j=1;j<=JACK;j++){
    erO   += (O   [j]-avO   )*(O   [j]-avO   );
    erchi += (chi [j]-avchi )*(chi [j]-avchi );
    ercum += (cum [j]-avcum )*(cum [j]-avcum );
    erE   += (E   [j]-avE   )*(E   [j]-avE   );
    erchie+= (chie[j]-avchie)*(chie[j]-erchie);
    ercume+= (cume[j]-avcume)*(cume[j]-avcume);
    ercumd+= (cumd[j]-avcumd)*(cumd[j]-avcumd);
    erlm  += (lm  [j]-avlm  )*(lm  [j]-avlm  );
    erlmd += (lmd [j]-avlmd )*(lmd [j]-avlmd );
    ercov += (cov [j]-avcov )*(cov [j]-avcov );
  }
  erO     = sqrt(erO   );
  erchi   = sqrt(erchi );
  ercum   = sqrt(ercum );
  erchie  = sqrt(erchie);
  erE     = sqrt(erE   );
  ercume  = sqrt(ercume);
  ercumd  = sqrt(ercumd);
  erlm    = sqrt(erlm  );
  erlmd   = sqrt(erlmd );
  ercov   = sqrt(ercov );
  avchi  *= M; erchi *= M;/*normalization of susceptibility*/
  avchie *= NE*beta*beta; erchie *= NE*beta*beta;
  printf("# N = %d data. JACK = % d groups\n",ndat+binw,JACK);
  printf("# Normalizations: NE= %lg  beta= %lg NM= %lg M= %lg\n",NE,beta,N,M );
  printf("#  MONTE CARLO VALUES OF OBSERVABLES\n");
  printf("#  E   = <E>/NE\n");
  printf("#  CV  = beta*2*(<E^2>-<E>^2)/NE\n");
  printf("#  O   = <|O|>/NM\n");
  printf("#  CHI = (<O^2>-<|O|>^2)*M\n");
  printf("#  BC  = <O^4>/<O^2>^2  = cumulant\n");
  printf("#  BCD = (<O^2><O^4 E>+<O^4>(<O^2><E>-2*<O^2 E>))/(<O^2>^3*NE)=d/d beta BC \n");
  printf("#  LO  = (<E>-<O   E>/<O  >)/NE = log of |O|\n");
  printf("#  LOD = (<E>-<O^2 E>/<O^2>)/NE = log of  O^2\n");
  printf("#  EC  = <E^4>/<E^2>^2 = Energy cumulant\n");
  printf("#  COV = (<EO>-<E><O>)/sqrt((<E^2>-<E>^2)(<O^2>-<O>^2))\n");
  printf("#  beta   E dE  CV dCV  O dO  CHI dCHI  BC dBC   BCD dBCD  LO dLO  LOD dLOD  EC dEC  COV dCOV");
  if(VERBOSE)
    printf("            NDAT  NDATinBIN  BINWIDTH JACKGRPS\n");
  else
    printf("\n");
  printf("#  ==========================================\n");

  printf("%lg  %.15lg %.15lg  %.15lg %.15lg  %.15lg %.15lg  %.15lg %.15lg  %.20lg %.20lg  %.15lg %.15lg  %.15lg %.15lg  %.15lg %.15lg  %.20lg %.20lg  %.20lg %.20lg",
	 beta, avE,erE, avchie,erchie, avO,erO, avchi,erchi, avcum,ercum,
	 avcumd,ercumd, avlm,erlm, avlmd,erlmd, avcume,ercume, avcov,ercov);
  if(VERBOSE)
    printf(" %d %d %d %d\n",ndat+binw,ndat,binw,JACK);
  else
    printf("\n");
}/*main*/


locerr( char *errmes ){

  fprintf(stderr,"%s: %s Exiting....\n",prog,errmes);
  exit(1);

}

#define OPTARGS  "?hn:N:m:M:j:vd:e:b:"
get_the_options(int argc,char **argv){


  int c,errflg = 0;

  while (!errflg && (c = getopt(argc, argv, OPTARGS)) != -1){
    switch(c){
    case 'e':
      NE= atof(optarg);
      break;
    case 'b':
      beta = atof(optarg);
      break;
    case 'v':
      VERBOSE = TRUE;
      break;
    case 'M':
    case 'm':
      M = atof(optarg);
      break;
    case 'N':
    case 'n':
      N = atof(optarg);
      break;
    case 'j':
      JACK = atoi(optarg);
      break;
    case 'd':
      maxdat = atoi(optarg);
      break;
    case 'h':
      errflg++;/*call usage*/
      break;
    case '?':
      errflg++;/*call usage*/
      break;
    default:
      errflg++;
    }/*switch*/
    if(errflg) usage(argv);
  }/*while...*/


}/*get_the_options()*/

usage(char **argv){

  fprintf(stderr,"\
Usage: %s  [options] <file>\n\
       -j  : No. jack groups Def. 10\n\
       -n,N: Normalization N of observable               Def. 1.0\n\
       -m,M: Normalization M of fluctuations             Def. N\n\
       -v  : Prints more information on the results line.\n\
       -d  : Give the maximum number of data points read.Def. %d\n\
       -e  : Normalization NE for energy.\n\
       -b  : beta for specific heat.\n\
Computes:\n\
=========\n\
E   = <E>/NE\n\
CV  = beta*2*(<E^2>-<E>^2)/NE\n\
O   = <|O|>/N\n\
CHI = (<O^2>-<|O|>^2)*M\n\
BC  = <O^4>/<O^2>^2  = cumulant\n\
BCD = (<O^2><O^4 E>+<O^4>(<O^2><E>-2*<O^2 E>))/(<O^2>^3*NE)=d/d beta BC \n\
LO  = (<E>-<O   E>/<O  >)/NE = log of |O|\n\
LOD = (<E>-<O^2 E>/<O^2>)/NE = log of  O^2\n\
EC  = <E^4>/<E^2>^2 = Energy cumulant\n\
Example:\n\
--------\n\
If O=M/N then in order to obtain chi_M you should use -m N\n\
If O=M                                                -n N\n\
-----------------------------------------------------------------------\n\
Data is in two columns in <file> or stdin, total energy and observable.\n\
K.Anagnostopoulos, NBI Sep 97.\n",prog,MAXDAT);

  exit(1);

}/*usage()*/
